const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Verification_submissionsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const verification_submissions = await db.verification_submissions.create(
            {
                id: data.id || undefined,
        
        badge_type: data.badge_type
        ||
        null
            ,
            
        status: data.status
        ||
        null
            ,
            
        notes: data.notes
        ||
        null
            ,
            
        admin_notes: data.admin_notes
        ||
        null
            ,
            
        created_at_ts: data.created_at_ts
        ||
        null
            ,
            
        updated_at_ts: data.updated_at_ts
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await verification_submissions.setBusiness( data.business || null, {
            transaction,
        });
        

        

        

        return verification_submissions;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const verification_submissionsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                badge_type: item.badge_type
            ||
            null
            ,
            
                status: item.status
            ||
            null
            ,
            
                notes: item.notes
            ||
            null
            ,
            
                admin_notes: item.admin_notes
            ||
            null
            ,
            
                created_at_ts: item.created_at_ts
            ||
            null
            ,
            
                updated_at_ts: item.updated_at_ts
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const verification_submissions = await db.verification_submissions.bulkCreate(verification_submissionsData, { transaction });

        // For each item created, replace relation files
        

        return verification_submissions;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const verification_submissions = await db.verification_submissions.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.badge_type !== undefined) updatePayload.badge_type = data.badge_type;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        if (data.notes !== undefined) updatePayload.notes = data.notes;
        
        
        if (data.admin_notes !== undefined) updatePayload.admin_notes = data.admin_notes;
        
        
        if (data.created_at_ts !== undefined) updatePayload.created_at_ts = data.created_at_ts;
        
        
        if (data.updated_at_ts !== undefined) updatePayload.updated_at_ts = data.updated_at_ts;
        
        
        updatePayload.updatedById = currentUser.id;

        await verification_submissions.update(updatePayload, {transaction});

        
        
        if (data.business !== undefined) {
            await verification_submissions.setBusiness(
              
              data.business,
              
              { transaction }
            );
        }
        

        
        

        

        return verification_submissions;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const verification_submissions = await db.verification_submissions.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of verification_submissions) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of verification_submissions) {
                await record.destroy({transaction});
            }
        });


        return verification_submissions;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const verification_submissions = await db.verification_submissions.findByPk(id, options);

        await verification_submissions.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await verification_submissions.destroy({
            transaction
        });

        return verification_submissions;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const verification_submissions = await db.verification_submissions.findOne(
            { where },
            { transaction },
        );

        if (!verification_submissions) {
            return verification_submissions;
        }

        const output = verification_submissions.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        output.verification_evidences_submission = await verification_submissions.getVerification_evidences_submission({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.business = await verification_submissions.getBusiness({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    const currentUser = options?.currentUser;

    // Data Isolation
    if (currentUser && currentUser.app_role) {
        const roleName = currentUser.app_role.name;
        if (roleName === 'Verified Business Owner') {
            if (currentUser.businessId) {
                where.businessId = currentUser.businessId;
            } else {
                where['$business.owner_userId$'] = currentUser.id;
            }
        }
    }

    let include = [

      {
        model: db.businesses,
        as: 'business',
        
        where: filter.business ? {
          [Op.or]: [
            { id: { [Op.in]: filter.business.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.business.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.notes) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'verification_submissions',
                        'notes',
                        filter.notes,
                    ),
                };
            }
            
            if (filter.admin_notes) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'verification_submissions',
                        'admin_notes',
                        filter.admin_notes,
                    ),
                };
            }
            

            
            

            
            if (filter.created_at_tsRange) {
                const [start, end] = filter.created_at_tsRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    created_at_ts: {
                    ...where.created_at_ts,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    created_at_ts: {
                    ...where.created_at_ts,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.updated_at_tsRange) {
                const [start, end] = filter.updated_at_tsRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    updated_at_ts: {
                    ...where.updated_at_ts,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    updated_at_ts: {
                    ...where.updated_at_ts,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.badge_type) {
                where = {
                    ...where,
                badge_type: filter.badge_type,
            };
            }
            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            


      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.verification_submissions.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'verification_submissions',
                        'notes',
                        query,
                    ),
                ],
            };
        }

        const records = await db.verification_submissions.findAll({
            attributes: [ 'id', 'notes' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['notes', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.notes,
        }));
    }

    
};